part of '../test.dart';

class AnnotationInstance {
  const AnnotationInstance();
}

const anno = const AnnotationInstance();

class UnusedAnnotation {
  const UnusedAnnotation();
}

class ClassAnnotation {
  const ClassAnnotation();
}

class MethodAnnotation {
  const MethodAnnotation();
}

@ClassAnnotation()
class ClassWithAnnotation {}

@ClassAnnotation()
class SecondClassWithAnnotation {}

/// Just to make sure classes without annotation aren't returned.
class RandomClass {}

@anno
foo() {}

abstract class MixinWithMethods {
  @MethodAnnotation()
  void interfaceMethod() {}

  void annotatedImplementation();
}

class SuperclassWithMethods {
  @MethodAnnotation()
  var superclassVariable;
}

class ClassWithMethods extends SuperclassWithMethods with MixinWithMethods {
  @anno
  get bar => null;

  @MethodAnnotation()
  methodWithAnnotation() {}

  @MethodAnnotation()
  anotherMethodWithAnnotation() {}

  methodWithoutAnnotation() {}

  @override
  @MethodAnnotation()
  annotatedImplementation() {}

  //Variables
  @MethodAnnotation()
  var variable;
}
